Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTexture.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTexture.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTexture.cpp	(revision 731)
@@ -2,73 +2,187 @@
 #include "IMGTexture.h"
 
-namespace IMG {
+namespace IMG 
+{
 
-    Texture::Texture()
+Texture::Texture(): references(0) // initialize references to 0
+{
+	mTexture = 0;
+	mWidth = 0;
+	mHeight = 0;
+	mMaterial = 0;
+	mCalculatedAvgColour = false;
+	mRectangle2D = new Ogre::Rectangle2D(true);
+	mRectangle2D->setBoundingBox(Ogre::AxisAlignedBox(-100000.0 * Ogre::Vector3::UNIT_SCALE, 100000.0 * Ogre::Vector3::UNIT_SCALE));
+	mRectangle2D->setRenderQueueGroup(Ogre::RENDER_QUEUE_OVERLAY);
+}
+
+Texture::~Texture()
+{
+	// Gametools -- BUG: 06/04/2006
+	//if (mRectangle2D)
+	//{
+	//	delete mRectangle2D;
+	//}
+
+	//if (mMaterial)
+	//{
+	//	delete mMaterial;
+	//}
+}
+
+Ogre::Rectangle2D* Texture::getRectangle2D()
+{
+	return mRectangle2D;
+}
+
+void Texture::setCorners(Ogre::Real left, Ogre::Real top, Ogre::Real right, Ogre::Real bottom)
+{
+	mRectangle2D->setCorners(left, top, right, bottom);
+}
+
+void Texture::bind(Ogre::String textureName)
+{		
+	if (!Ogre::TextureManager::getSingleton().getByName(textureName).isNull())
 	{
+		mTexture = (Ogre::Texture*) Ogre::TextureManager::getSingleton().getByName(textureName).getPointer();
+		mWidth = mTexture->getSrcWidth();
+		mHeight = mTexture->getSrcHeight();
+	}
+	else
+	{
+		Ogre::TexturePtr tPtr = Ogre::TextureManager::getSingleton().load(textureName, Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
+
+		mTexture = (Ogre::Texture*) tPtr.getPointer();
+		mWidth = mTexture->getSrcWidth();
+		mHeight = mTexture->getSrcHeight();
+	}
+}
+
+void Texture::setBackgroundColour(Ogre::ColourValue colour)
+{
+	mBackgroundColour = colour;
+}
+
+Ogre::ColourValue Texture::getBackgroundColour()
+{
+	return mBackgroundColour;
+}
+
+Ogre::ColourValue Texture::getAvgColour()
+{
+	if (mCalculatedAvgColour)
+	{
+		return mAvgColour;
+	}
+	else
+	{
+		calculateAvgColour();
+		return mAvgColour;
+	}
+}
+
+void Texture::calculateAvgColour()
+{
+	unsigned int cR = 0;
+	unsigned int cG = 0;
+	unsigned int cB = 0;
+	unsigned int cA = 0;
+
+	Ogre::Image img;
+	img.load(mTexture->getName(), Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME); 
+	unsigned char* data = static_cast<unsigned char*>(img.getData());
+
+	unsigned int nColorpixels = 1;
+
+	for (unsigned int i = 0; i < mTexture->getWidth() * mTexture->getHeight() * 4; i=i+4)
+	{
+		cA = (unsigned short int)data[i+3];
+		if (cA != 0)
+		{
+			cB = cB + data[i+2];
+			cG = cG + data[i+1];
+			cR = cR + data[i];				
+
+			nColorpixels++;
+			//Ogre::LogManager::getSingleton().logMessage("(" + Ogre::StringConverter::toString(data[i]) + "," + Ogre::StringConverter::toString(data[i+1]) + "," + Ogre::StringConverter::toString(data[i+2]) + "," + Ogre::StringConverter::toString(data[i+3]) + ")");
+		}					
 	}
 
-    virtual Texture::~Texture()
-	{
-	}
+	cR = cR / nColorpixels;
+	cG = cG / nColorpixels;
+	cB = cB / nColorpixels;
 
-    void Texture::setTextureHandle(unsigned int textureHandle)
-	{
-		mTextureHandle = textureHandle;
-	}
+	mAvgColour = Ogre::ColourValue(cR/255.0, cG/255.0, cB/255.0, 0.0);
+	mCalculatedAvgColour = true;
+}
 
-    unsigned int Texture::getTextureHandle()
-	{
-		return mTextureHandle;
-	}
+void Texture::load(Ogre::String folderName, Ogre::String fileName)
+{
+	Ogre::TextureManager::getSingleton().load(fileName, Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
+	mTexture = (Ogre::Texture*)Ogre::TextureManager::getSingleton().getByName(fileName).getPointer();
+	mWidth = mTexture->getSrcWidth();
+	mHeight = mTexture->getSrcHeight();
+}
 
-    Ogre::String Texture::getMaterialName()
-	{
-		return mMaterialName;
-	}
+void Texture::save(Ogre::String folderName, Ogre::String filename)
+{
+    Ogre::HardwarePixelBufferSharedPtr readbuffer;
+    readbuffer = mTexture->getBuffer(0, 0);
+	unsigned char *tex = new unsigned char[readbuffer->getSizeInBytes()];
+	Ogre::PixelBox *pBox = new Ogre::PixelBox(mTexture->getWidth(), mTexture->getHeight(), mTexture->getDepth(), mTexture->getFormat(), tex);
+    readbuffer->blitToMemory((*pBox));
+    
+    Ogre::Image img;
+    img = img.loadDynamicImage(tex, mTexture->getWidth(), mTexture->getHeight(), mTexture->getDepth(), mTexture->getFormat(), true, 1, 0);		
+	img.resize(mWidth, mHeight);
+    img.save(folderName + filename);
+	delete pBox;
+}
 
-    void Texture::setMaterialName(Ogre::String materialName)
-	{
-		mMaterialName = materialName;
-	}
+void Texture::rotate(Ogre::Real rRotation)
+{
+	//mTexture->setTextureRotate( Degree( -rRotation ) );
+}
 
-    void Texture::setWidth(unsigned int width)
-	{
-		mWidth = width;
-	}
+void Texture::setWidth(unsigned int width)
+{
+	mWidth = width;
+}
 
-    unsigned int Texture::getWidth()
-	{
-		return mWidth;
-	}
+unsigned int Texture::getWidth()
+{
+	return mWidth;
+}
 
-    void Texture::setHeight(unsigned int height)
-	{
-		mHeight = height;
-	}
+void Texture::setHeight(unsigned int height)
+{
+	mHeight = height;
+}
 
-    unsigned int Texture::getHeight()
-	{
-		return mHeight;
-	}
+unsigned int Texture::getHeight()
+{
+	return mHeight;
+}
 
-    void Texture::setRenderTargetName(Ogre::String renderTargetName)
-	{
-		mRenderTargetName = renderTargetName;
-	}
+void Texture::setTextureName(Ogre::String textureName)
+{
+	mTextureName = textureName;
+}
 
-    Ogre::String Texture::getRenderTarget()
-	{
-		return mRenderTargetName;
-	}
+Ogre::String Texture::getTextureName()
+{
+	return mTextureName;
+}
 
-    void Texture::setTextureName(Ogre::String textureName)
-	{
-		mTextureName = textureName;
-	}
+void Texture::setMaterial(Ogre::Material *material)
+{
+	mMaterial = material;
+	mRectangle2D->setMaterial(mMaterial->getName());
+}
 
-    Ogre::String Texture::getTextureName()
-	{
-		return mTextureName;
-	}
+Ogre::Material* Texture::getMaterial()
+{
+	return mMaterial;
+}
 
 }
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCClusterViewMode.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCClusterViewMode.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCClusterViewMode.cpp	(revision 731)
@@ -1,4 +1,4 @@
 
-#include "LBBCClustersViewMode.h"
+#include "LBBCClusterViewMode.h"
 
 namespace LBBC {
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCBillboardKMeansClusterData.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCBillboardKMeansClusterData.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCBillboardKMeansClusterData.cpp	(revision 731)
@@ -36,5 +36,4 @@
 	TiXmlNode *quadBottomRightCornerNode;
 	TiXmlNode *quadBottomLeftCornerNode;
-	TiXmlNode *axisXNode;
 	TiXmlNode *axisYNode;
 	TiXmlNode *axisZNode;
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloudUVMapper.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloudUVMapper.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCBillboardCloudUVMapper.cpp	(revision 731)
@@ -124,10 +124,10 @@
 	Ogre::LogManager::getSingleton().logMessage("iBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds) + "-" + "iBBCG:" + Ogre::StringConverter::toString(iBillboardGroup));
 
-	Ogre::LogManager::getSingleton().logMessage("SizeCLList:" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->GetSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
-
-	IMG::Cluster *cluster = getClusterList(iBillboardGroup)->Get(getClusterList(iBillboardGroup)->GetSize()-1);		
-	IMG::Box2d *box = cluster->GetBspNodeBound();
-	Ogre::Vector2 max = box->GetMaximum();
-	Ogre::Vector2 min = box->GetMinimum();
+	Ogre::LogManager::getSingleton().logMessage("SizeCLList:" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
+
+	IMG::Cluster *cluster = getClusterList(iBillboardGroup)->get(getClusterList(iBillboardGroup)->getSize()-1);		
+	IMG::Box2d *box = cluster->getBspNodeBound();
+	Ogre::Vector2 max = box->getMaximum();
+	Ogre::Vector2 min = box->getMinimum();
 	Ogre::LogManager::getSingleton().logMessage("Max:" + Ogre::StringConverter::toString(Ogre::Vector3(max[0],max[1],0)) + 
 		"\tMin:" + Ogre::StringConverter::toString(Ogre::Vector3(min[0],min[1],0)) + 
@@ -282,9 +282,9 @@
 	Ogre::LogManager::getSingleton().logMessage("w:" + Ogre::StringConverter::toString(mTextureWidth));
 	Ogre::LogManager::getSingleton().logMessage("h:" + Ogre::StringConverter::toString(mTextureHeight));
-	nodeDest = getBsp(iBillboardGroup)->Insert(mTextureWidth,mTextureHeight,iBillboard);
+	nodeDest = getBsp(iBillboardGroup)->insert(mTextureWidth,mTextureHeight,iBillboard);
 	
-	cluster.SetBspNodeBound(nodeDest->GetBound());
-	//cluster.Finish();
-	getClusterList(iBillboardGroup)->Insert(&cluster);	
+	cluster.setBspNodeBound(nodeDest->getBound());
+	//cluster.finish();
+	getClusterList(iBillboardGroup)->insert(&cluster);	
 }
 
@@ -353,6 +353,6 @@
 		IMG::NodeBspPtr node = IMG::NodeBspPtr(new IMG::NodeBsp);
 
-		node->GetBound()->SetBoundBox(0, 0, mTextureAtlasWidth, mTextureAtlasHeight);
-		bsp->SetRoot(node);	
+		node->getBound()->setBoundBox(0, 0, mTextureAtlasWidth, mTextureAtlasHeight);
+		bsp->setRoot(node);	
 
 		addBsp(bsp);
@@ -379,5 +379,5 @@
 				{
 					Ogre::LogManager::getSingleton().logMessage("\nA");
-					Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->GetSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
+					Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
 
 					addTextureInBsp(iBillboardGroup, iBillboard);
@@ -391,5 +391,5 @@
 					{
 						Ogre::LogManager::getSingleton().logMessage("\nB");
-						Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->GetSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
+						Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
 
 						addTextureInBsp(iBillboardGroup, iBillboard);
@@ -403,6 +403,6 @@
 						iBillboardsInGroup = 0;
 
-						Ogre::LogManager::getSingleton().logMessage("\nC IG:" + Ogre::StringConverter::toString(iBillboardsInGroup-1) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup-1) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup-1)->GetSize()));
-						Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->GetSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
+						Ogre::LogManager::getSingleton().logMessage("\nC IG:" + Ogre::StringConverter::toString(iBillboardsInGroup-1) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup-1) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup-1)->getSize()));
+						Ogre::LogManager::getSingleton().logMessage("IG:" + Ogre::StringConverter::toString(iBillboardsInGroup) + " SizeCLList(" + Ogre::StringConverter::toString(iBillboardGroup) + "):" + Ogre::StringConverter::toString(getClusterList(iBillboardGroup)->getSize()) + " -- numBBC:" + Ogre::StringConverter::toString(numGeneratedBillboardClouds));
 
 						addTextureInBsp(iBillboardGroup, iBillboard);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGClusterList.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGClusterList.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGClusterList.cpp	(revision 731)
@@ -9,5 +9,5 @@
 }
 
-bool ClusterList::Insert(Cluster * p) 
+bool ClusterList::insert(Cluster * p) 
 {
 	if (!p)
@@ -21,10 +21,11 @@
 }
 
-void ClusterList::Print() 
+void ClusterList::print() 
 {
 	Ogre::LogManager::getSingleton().logMessage("nNombre de  cluster a la llista: " + Ogre::StringConverter::toString(list.size()));
+
 	for (register int i = 0; i < list.size(); i ++)
 	{
-		Get(i)->Print();
+		this->get(i)->print();
 	}	
 }
@@ -35,15 +36,15 @@
 }
 
-std::vector<Cluster> * ClusterList::GetList() 
+std::vector<Cluster> * ClusterList::getList() 
 {
 	return &list;
 }
 
-unsigned int ClusterList::GetSize() const
+unsigned int ClusterList::getSize() const
 { 
 	return list.size(); 
 }
 
-Cluster * ClusterList::Get(unsigned int i) 
+Cluster * ClusterList::get(unsigned int i) 
 {
     if (i <= list.size())
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBox2d.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBox2d.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBox2d.cpp	(revision 731)
@@ -18,15 +18,15 @@
 }
 
-Ogre::Vector2 Box2d::GetMinimum() 
+Ogre::Vector2 Box2d::getMinimum() 
 { 
     return mMinimum;
 }
 
-Ogre::Vector2 Box2d::GetMaximum() 
+Ogre::Vector2 Box2d::getMaximum() 
 { 
     return mMaximum; 
 }
 
-void Box2d::SetBoundBox(float x, float y, float X, float Y) 
+void Box2d::setBoundBox(float x, float y, float X, float Y) 
 {
     mMinimum.x = x;
@@ -36,5 +36,5 @@
 }
 
-void Box2d::AddBoundingVector3(float x, float y)
+void Box2d::addBoundingVector3(float x, float y)
 {
     if (x < mMinimum.x)
@@ -59,10 +59,10 @@
 }
 
-void Box2d::Print()
+void Box2d::print()
 {
 	Ogre::LogManager::getSingleton().logMessage("Valor de la Caixa: (" + Ogre::StringConverter::toString(Ogre::Vector3(mMinimum.x, mMinimum.y, 0)) + ") - (" + Ogre::StringConverter::toString(Ogre::Vector3(mMaximum.x, mMaximum.y, 0)) + ")");
 }
 
-Ogre::Vector2 Box2d::GetCorner(int corner) const 
+Ogre::Vector2 Box2d::getCorner(int corner) const 
 {
 	Ogre::Vector2 vector;
@@ -79,5 +79,5 @@
 }
 
-bool Box2d::In(int w, int h) 
+bool Box2d::in(int w, int h) 
 {
     if (w <= (mMaximum.x - mMinimum.x) && h <= (mMaximum.y - mMinimum.y))
@@ -89,5 +89,5 @@
 }
 
-bool Box2d::FitPerfect(int w, int h)
+bool Box2d::fitPerfect(int w, int h)
 {	
     if (w == (mMaximum.x - mMinimum.x) && h == (mMaximum.y - mMinimum.y))
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGCluster.cpp	(revision 731)
@@ -13,50 +13,50 @@
 }
 
-void Cluster::SetNormal(Ogre::Vector3* n) 
+void Cluster::setNormal(Ogre::Vector3* n) 
 { 
 	normal = *n; 
 }
 
-Ogre::Vector3* Cluster::GetNormal() 
+Ogre::Vector3* Cluster::getNormal() 
 { 
 	return &normal; 
 }
 
-BBox* Cluster::GetBound() 
+BBox* Cluster::getBound() 
 { 
 	return &bound; 
 }
 
-Box2d* Cluster::GetBspNodeBound() 
+Box2d* Cluster::getBspNodeBound() 
 { 
 	return &bspnodebound; 
 }
 
-void Cluster::SetBspNodeBound(Box2d* box) 
+void Cluster::setBspNodeBound(Box2d* box) 
 {
 	bspnodebound = (*box);
 }
 
-int Cluster::GetId() const 
+int Cluster::getId() const 
 { 
 	return id; 
 }
 
-void Cluster::SetId(int id_) 
+void Cluster::setId(int id_) 
 { 
 	id = id;
 }
 
-	std::vector<Ogre::Vector3>* Cluster::GetVector3sVector() 
+std::vector<Ogre::Vector3>* Cluster::getVector3sVector() 
 { 
 	return &Vector3s_vector; 
 }
 
-Ogre::Vector3* Cluster::GetVector3sTex() const 
+Ogre::Vector3* Cluster::getVector3sTex() const 
 { 
 	return Vector3s_triangle_text;
 }
 
-void Cluster::SetPlane(Ogre::Vector3* normal, Ogre::Vector3 * point) 
+void Cluster::setPlane(Ogre::Vector3* normal, Ogre::Vector3 * point) 
 {
     plane.normal = *normal;
@@ -65,5 +65,5 @@
 }
 
-Plane3 * Cluster::GetPlane()
+Plane3 * Cluster::getPlane()
 { 
 	return &plane; 
@@ -108,16 +108,16 @@
 }
 
-void Cluster::Print() 
+void Cluster::print() 
 {
 	Ogre::LogManager::getSingleton().logMessage("\n\nCluster: " + Ogre::StringConverter::toString(id) + ", axisproj: " + Ogre::StringConverter::toString(axisproj)  + ", order: " + Ogre::StringConverter::toString(order));
 	
-	plane.Print();
+	plane.print();
 	Ogre::LogManager::getSingleton().logMessage("\nOrigin (" + Ogre::StringConverter::toString(lumel_origin) + ")");
 	Ogre::LogManager::getSingleton().logMessage("Inc U (" + Ogre::StringConverter::toString(lumel_x_axis) + ")");
 	Ogre::LogManager::getSingleton().logMessage("Inc V (" + Ogre::StringConverter::toString(lumel_y_axis.z) + ")");
 	
-	bound.Print();
-
-	bspnodebound.Print();
+	bound.print();
+
+	bspnodebound.print();
 	
 	Ogre::LogManager::getSingleton().logMessage("Printant els vertexs: ");
@@ -125,7 +125,7 @@
 
 //* return the dominant normal axis, for calculate the 2d projection
-int Cluster::AxisProjected() {
-	
-	Ogre::Vector3 *normal = plane.GetNormal();
+int Cluster::axisProjected() 
+{
+	Ogre::Vector3 *normal = plane.getNormal();
 	
 	if (Ogre::Math::Abs(normal->x) >= Ogre::Math::Abs(normal->y) && Ogre::Math::Abs(normal->x) >= Ogre::Math::Abs(normal->z))
@@ -143,38 +143,35 @@
 }
 
-void Cluster::Finish() 
+void Cluster::finish() 
 {
 	Ogre::LogManager::getSingleton().logMessage("\nCluster::Finish()");
-	Plane3 *plane = GetPlane();
-	Ogre::Vector3 normal = *plane->GetNormal();
-	float distance = plane->GetDistance();
+	Plane3 *plane = getPlane();
+	Ogre::Vector3 normal = *plane->getNormal();
+	float distance = plane->getDistance();
 	Ogre::Vector3 corner;
 	Cluster2d cluster2d;		
 	Ogre::Vector3 vertexfinal[3];
-	Ogre::Vector2 *vertexs2d;
 	int num_vertexs = 4;
-	//Box box;
 	Ogre::Vector3 min;
 	Ogre::Vector3 max;
-	float num, den;	
 	bool type = true;
 
 	Ogre::LogManager::getSingleton().logMessage("\tCreant cluster 2d");
-	axisproj = cluster2d.Create2d (this, 0, true);	
+	axisproj = cluster2d.create2d (this, 0, true);	
 	Ogre::LogManager::getSingleton().logMessage("\t Imprimint el que hi al del cluster");
 		
 	std::vector<Ogre::Vector2> vector2;
-	vector2 =*cluster2d.GetVector3sVector();
+	vector2 =*cluster2d.getVector3sVector();
 	
 	for (unsigned int i = 0; i < vector2.size(); i++)
 	{		
-		bound.AddBoundingVector3 (vector2[i].x, vector2[i].y, 0);		
-	}
-	
-	min = bound.GetMinimum();	
-	max = bound.GetMaximum();
+		bound.addBoundingVector3 (vector2[i].x, vector2[i].y, 0);		
+	}
+	
+	min = bound.getMinimum();	
+	max = bound.getMaximum();
 	
 	Ogre::LogManager::getSingleton().logMessage("Caixa Englobant del cluster 2d");
-	bound.Print();
+	bound.print();
 
 	Ogre::Vector3 aux (-9999,-9999,-9999);
@@ -184,5 +181,5 @@
 
 //* Return the increment in U (lumel increment in x). For patchs calculation 
-Ogre::Vector3 Cluster::GetIncU() 
+Ogre::Vector3 Cluster::getIncU() 
 { 
 	return lumel_x_axis;
@@ -190,10 +187,10 @@
 
 //* Return the increment in V (lumel increment in x). For patchs calculation 
-Ogre::Vector3 Cluster::GetIncV() 
+Ogre::Vector3 Cluster::getIncV() 
 {
 	return lumel_y_axis;
 }
 
-Ogre::Vector3 Cluster::GetOrigin() 
+Ogre::Vector3 Cluster::getOrigin() 
 {
 	return lumel_origin;
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCManager.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCManager.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/BBCManager.cpp	(revision 731)
@@ -4,33 +4,33 @@
 namespace BBC {
 
-template <> Manager* CSingleton<Manager>::ms_Singleton = NULL;
+template <> BBCManager* CSingleton<BBCManager>::ms_Singleton = NULL;
 
-Manager* Manager::getSingletonPtr(void)
+BBCManager* BBCManager::getSingletonPtr(void)
 {
     return ms_Singleton;
 }
 
-Manager& Manager::getSingleton(void)
+BBCManager& BBCManager::getSingleton(void)
 {  
     assert( ms_Singleton );  return ( *ms_Singleton );  
 }
 
-Manager::Manager() 
+BBCManager::BBCManager() 
 {   
 }
 
-Manager::~Manager() 
+BBCManager::~BBCManager() 
 {
 }
 
-void Manager::shutdown()
+void BBCManager::shutdown()
 {
 }
 
-void Manager::initialize()
+void BBCManager::initialize()
 {
 }
 
-Ogre::Mesh* Manager::loadMesh(Ogre::String folderName, Ogre::String fileName)
+Ogre::Mesh* BBCManager::loadMesh(Ogre::String folderName, Ogre::String fileName)
 {	
 	//std::ifstream ifs;
@@ -42,10 +42,10 @@
 	Ogre::ResourceGroupManager::getSingleton().addResourceLocation(folderName, "FileSystem", fileName, false);
 
-	Ogre::MeshPtr mesh = OBA::OgreBase::getSingleton().getMeshManager()->load(fileName, fileName);
+	Ogre::MeshPtr mesh = Ogre::MeshManager::getSingleton().load(fileName, fileName);
 
 	return mesh.getPointer();
 }
 
-Ogre::Mesh* Manager::loadXMLMesh(Ogre::String name)
+Ogre::Mesh* BBCManager::loadXMLMesh(Ogre::String name)
 {
 	Ogre::MeshPtr newMesh = Ogre::MeshManager::getSingleton().createManual(name.substr(0,((name.size()-1)-4)),Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
@@ -68,5 +68,5 @@
 }
 
-void Manager::saveMesh(Ogre::String name)
+void BBCManager::saveMesh(Ogre::String name)
 {
 	Ogre::MeshPtr meshPtr = Ogre::MeshManager::getSingleton().getByName(name);
@@ -74,5 +74,5 @@
 }
 
-void Manager::saveXMLMesh(Ogre::String name)
+void BBCManager::saveXMLMesh(Ogre::String name)
 {
 	Ogre::MeshPtr meshPtr = Ogre::MeshManager::getSingleton().getByName(name);
@@ -80,3 +80,19 @@
 }
 
+void BBCManager::saveMaterial(Ogre::String materialName)
+{
+	Ogre::ResourceManager::ResourceMapIterator it = Ogre::MaterialManager::getSingleton().getResourceIterator();
+    while (it.hasMoreElements())
+    {
+		Ogre::MaterialPtr m = it.getNext();
+        
+        if (m->getName() == materialName)
+		{
+			OBA::OgreBase::getSingleton().getMaterialSerializer()->queueForExport(m);
+			break;
+		}
+    }
+    //OBA::OgreBase::getSingleton().getMaterialSerializer()->exportQueued(dest);
 }
+
+}
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTextureAtlas.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTextureAtlas.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGTextureAtlas.cpp	(revision 731)
@@ -4,47 +4,146 @@
 namespace IMG {
 
-    TextureAtlas::TextureAtlas()
+TextureAtlas::TextureAtlas(): references(0) // initialize references to 0
+{
+	mRectangle2D->setBoundingBox(Ogre::AxisAlignedBox(-100000.0 * Ogre::Vector3::UNIT_SCALE, 100000.0 * Ogre::Vector3::UNIT_SCALE));
+	mRectangle2D->setRenderQueueGroup(Ogre::RENDER_QUEUE_BACKGROUND);
+}
+
+TextureAtlas::~TextureAtlas()
+{
+	mTextureList.clear();
+}
+
+unsigned int TextureAtlas::getReference()
+{
+	return references;
+}
+
+void TextureAtlas::setTextureAtlasName(Ogre::String textureAtlasName)
+{
+	mTextureAtlasName = textureAtlasName;
+}
+
+Ogre::String TextureAtlas::getTextureAtlasName()
+{
+	return mTextureAtlasName;
+}
+
+void TextureAtlas::addTexture(TexturePtr texture)
+{
+	mTextureList.push_back(texture);
+	mTextureAtlasSceneNode->attachObject(texture->getRectangle2D());
+}
+
+TexturePtr TextureAtlas::getTexture(unsigned int iTexture)
+{
+	return mTextureList[iTexture];
+}
+
+void TextureAtlas::removeTexture(unsigned int iTexture)
+{
+	mTextureList.erase(mTextureList.begin()+iTexture);
+}
+
+unsigned int TextureAtlas::getNumTextures()
+{
+	return mTextureList.size();
+}
+
+void TextureAtlas::setTextureAtlasSceneNode(Ogre::SceneNode *textureAtlasSceneNode)
+{
+	mTextureAtlasSceneNode = textureAtlasSceneNode;	
+	mTextureAtlasSceneNode->attachObject(mRectangle2D);
+}
+
+Ogre::SceneNode* TextureAtlas::getTextureAtlasSceneNode()
+{
+	return mTextureAtlasSceneNode;
+}
+
+void TextureAtlas::setCamera(Ogre::Camera *camera)
+{
+	mCamera = camera;
+}
+
+void TextureAtlas::update()
+{
+	mTexture->getBuffer(0, 0)->getRenderTarget()->update();
+}
+
+void TextureAtlas::save(Ogre::String folderName, Ogre::String fileName, Ogre::PixelFormat pixelFormat)
+{	
+	unsigned char* pBufferBox = new unsigned char[mTexture->getBuffer(0, 0)->getSizeInBytes()];
+	unsigned char* pBufferDest = new unsigned char[mTexture->getBuffer(0, 0)->getSizeInBytes()];
+
+    // Read pixels	
+	Ogre::PixelBox pBox(mWidth, mHeight, 1, mPixelFormat, pBufferBox);
+	Ogre::PixelBox pDest(mWidth, mHeight, 1, pixelFormat, pBufferDest);	
+	mTexture->getBuffer(0, 0)->blitToMemory(pBox);
+	Ogre::PixelUtil::bulkPixelConversion(pBox.data,mPixelFormat,pDest.data,pixelFormat,pBox.getWidth()*pBox.getHeight());
+
+	//if (pixelFormat == Ogre::PF_FLOAT32_RGBA)
+	//{
+	//	imdebug("rgba w=%d h=%d %p b=32f",pDest.getWidth(),pDest.getHeight(),pDest.data);
+	//}
+
+	// copyToMemory
+	Ogre::ImageCodec::ImageData *imgData = new Ogre::ImageCodec::ImageData();
+    
+    imgData->width = mWidth;
+    imgData->height = mHeight;
+	imgData->depth = 1;	
+    imgData->format = pixelFormat;
+
+	// Wrap buffer in a chunk
+	Ogre::MemoryDataStreamPtr stream(new Ogre::MemoryDataStream(pBufferDest, mTexture->getBuffer(0, 0)->getSizeInBytes(), false));
+
+    // Get codec 
+    size_t pos = fileName.find_last_of(".");
+    Ogre::String extension;
+    if( pos == Ogre::String::npos )
 	{
+        OGRE_EXCEPT(Ogre::Exception::ERR_INVALIDPARAMS, "Unable to determine image type for '" + fileName + "' - invalid extension.", "GLRenderTexture::writeContentsToFile" );
 	}
 
-    virtual TextureAtlas::~TextureAtlas()
+    while( pos != fileName.length() - 1 )
 	{
+        extension += fileName[++pos];
 	}
 
-    void TextureAtlas::setRenderSourceName(Ogre::String renderSourceName)
-	{
-		mRenderSourceName = renderSourceName;
-	}
+    // Get the codec
+    Ogre::Codec * pCodec = Ogre::Codec::getCodec(extension);
 
-    Ogre::String TextureAtlas::getRenderSourceName()
-	{
-		return mRenderSourceName;
-	}
+    // Write out
+    Ogre::Codec::CodecDataPtr codecDataPtr(imgData);
 
-	void TextureAtlas::setRenderSourceName(Ogre::String renderSourceName)
-	{
-		mRenderSourceName = renderSourceName;
-	}
+	pCodec->codeToFile(stream,folderName + fileName, codecDataPtr);
 
-	void TextureAtlas::addTexture(Texture *texture)
-	{
-		mTextureList.push_back(texture);
-	}
+	delete [] pBufferDest;
+	delete [] pBufferBox;
+}
 
-	void TextureAtlas::getTexture(unsigned int iTexture)
-	{
-		return mTextureList[iTexture];
-	}
+void TextureAtlas::setFormat(Ogre::PixelFormat pixelFormat)
+{
+	mPixelFormat = pixelFormat;
+}
 
-	void TextureAtlas::removeTexture(unsigned int iTexture)
-	{
-		Texture *texture = mTextureList[iTexture];
-		mTextureList.erase(mTextureList.begin()+iTexture);
-		delete texture;
-	}
+void TextureAtlas::create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera)
+{
+	mCamera = camera;
+	mWidth = width;
+	mHeight = height;
+	mPixelFormat = pixelFormat;
+	mTexture = Ogre::TextureManager::getSingleton().createManual(fileName, "General", Ogre::TEX_TYPE_2D, mWidth, mHeight, 0, mPixelFormat, Ogre::TU_RENDERTARGET).getPointer();
+	mTexture->getBuffer(0, 0)->getRenderTarget();
+	Ogre::RenderTexture *rt = mTexture->getBuffer()->getRenderTarget();
+	rt->setAutoUpdated(false);
+	Ogre::Viewport *v = rt->addViewport(mCamera);
+	v->setClearEveryFrame(true);
+	v->setBackgroundColour(Ogre::ColourValue(1.0f, 1.0f, 1.0f, 0.0f));
+	v->setOverlaysEnabled(false);
+	v->setDimensions(0,0,1.0,1.0);	
+	Ogre::Root::getSingleton().getRenderSystem()->clearFrameBuffer(Ogre::FBT_COLOUR, Ogre::ColourValue(1.0f,1.0f,1.0f,0.0f) );
+}
 
-	unsigned int TextureAtlas::getNumTextures()
-	{
-		return mTextureList.size();
-	}
 }
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBBox.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBBox.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IMGBBox.cpp	(revision 731)
@@ -6,5 +6,5 @@
 BBox::BBox()
 { 
-	BBox::StartBoundingBox(); 
+	BBox::initialize(); 
 }
 
@@ -13,5 +13,5 @@
 }
 
-void BBox::StartBoundingBox()
+void BBox::initialize()
 {
 	mMinimum.x =  BOUNDINGBOX_MAXVALUE;
@@ -23,15 +23,15 @@
 }
 
-Ogre::Vector3 BBox::GetMinimum() 
+Ogre::Vector3 BBox::getMinimum() 
 { 
 	return mMinimum; 
 }
 
-Ogre::Vector3 BBox::GetMaximum()
+Ogre::Vector3 BBox::getMaximum()
 { 
 	return mMaximum;
 }
 
-void BBox::AddBoundingVector3(float x, float y, float z)
+void BBox::addBoundingVector3(float x, float y, float z)
 {
     if (x < mMinimum.x)
@@ -66,10 +66,10 @@
 }
 
-void BBox::Print() 
+void BBox::print() 
 {
 	Ogre::LogManager::getSingleton().logMessage("\nValor de la Caixa: (" + Ogre::StringConverter::toString(mMinimum) + ") - (" + + ") " + Ogre::StringConverter::toString(mMaximum));
 }
 
-Ogre::Vector3 BBox::GetCorner(int corner) const 
+Ogre::Vector3 BBox::getCorner(int corner) const 
 {
     Ogre::Vector3 vector;    	
